import { ElMessage } from 'element-plus'
import type { CellSlotProps } from '../type'

export default function useTableCellClick(tableName?: string) {
  const router = useRouter()
  const route = useRoute()
  const cellClickHandler = (row, column, cell, event) => {
    switch (tableName) {
      case 'flightWaybill':
        switch (column.property) {
          case 'C0':
            router.push({
              path: `${route.path.split('/').slice(0, -1).join('/')}/waybill`,
              query: {
                waybillNo: row.C0,
              },
            })
            break
          case 'C1':
            ElMessage.info('开发中')
            break
          default:
            break
        }
        break
      case 'flightContainer':
        switch (column.property) {
          case 'C0':
            ElMessage.info('开发中')
        }
        break
      case 'waybillGoods':
        switch (column.property) {
          case 'C2':
            router.push({
              path: `${route.path.split('/').slice(0, -1).join('/')}/goods`,
              query: {
                waybillNo: row.C2,
              },
            })
            break
          default:
            break
        }
        break
      default:
        break
    }
  }
  const cellClickHandlerV2 = ({ column, rowData }: CellSlotProps) => {
    switch (column.columnName) {
      case 'flightNO':
        router.push({
          path: `${route.path.split('/').slice(0, -1).join('/')}/flight`,
          query: {
            flightNO: rowData.flightNO,
            flightDate: rowData.flightDate,
          },
        })
        break
      default:
        break
    }
  }

  return {
    cellClickHandler,
    cellClickHandlerV2,
  }
}
